import "pixie"

class("Ball", {
         direction = {x=-1, y=1},
         speed     = 3,
}).extends(Pixie)

function Ball:init(width, height, color, x, y)
   Ball.super.init(self, width, height, color, x, y)
   return self
end

function Ball:levelUp()
   self.speed += 1
end

function Ball:move()
   self:moveBy(self.direction.x * self.speed,
               self.direction.y * self.speed)
end

function Ball:setDirection(x, y)
   x = x or self.direction.x
   y = y or self.direction.y
   self.direction.x = x
   self.direction.y = y
end

function Ball:_normalizePosition()
   local changeVector = Ball.super._normalizePosition(self)
   if changeVector[1] ~= 0 then
      self.direction.x = changeVector[1]
   end
   if changeVector[2] ~= 0 then
      self.direction.y = changeVector[2]
   end
end
